//ImageFile.h
#include <afxwin.h>         // MFC core and standard components

#define HDIB HANDLE

static const int RGBSample = 3;
static const int GRAYSample = 1;

//------------------------------------------------------------
//ImageFile class
//------------------------------------------------------------
class ImageFile {

public:
	ImageFile(BOOL openFile = TRUE);
	~ImageFile();
	virtual BOOL OpenFile();
	virtual BOOL SaveFile();
	virtual HDIB GetImageDib();
	virtual BOOL PutScanline(unsigned char* pBuffer);
	virtual void Reset(int height = 0, int width = 0, int nSamples = 0);
	virtual int Width() { return image_width; }
	virtual int Height() { return image_height; }
	virtual int CurrentRow() { return currnt_row; }
	virtual BOOL ImageLoaded() { return imageLoaded; }
	virtual int SamplesPerPixel() { return SamplePerPixel; }
//	virtual RGBColor GetRGBColorPixel(int x, int y);
//	virtual BOOL PutRGBColorRow(RGBColor* pBuffer);

private:
	virtual BOOL AllocateImage();
	virtual void DeallocateImage();
	virtual BOOL LoadJpeg();
	virtual BOOL LoadTiff();
	virtual BOOL LoadDib();
	virtual BOOL LoadTga();
	virtual BOOL SaveJpeg(int quality, int mode24);
	virtual BOOL SaveTiff(int mode24);
	virtual BOOL SaveDib();
	virtual BOOL SaveTga(int mode24);
	
private:
	char* filename;
	int image_height;
	int image_width;
	int currnt_row;		//used for adding scanlines from the outside
	int SamplePerPixel;
	BOOL imageLoaded;
	unsigned char** pImage;

};