// ===================================================================
//  File: Dialogs.cpp					5/1/2000
//	By Konstantin Khanyants
//	Description:
//		Functions of the ImageFile class that are used
//		to interact with dialog used to set the settings of
//		various file formats upon saving the image.
//
// ===================================================================

#include "stdafx.h"
#include "Dialogs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJpegDlg dialog


CJpegDlg::CJpegDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJpegDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJpegDlg)
	m_Quality = 10;
	m_Mode = 1;
	//}}AFX_DATA_INIT
}


void CJpegDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJpegDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_QualitySlider);
	DDX_Text(pDX, IDC_EDIT1, m_Quality);
	DDV_MinMaxInt(pDX, m_Quality, 0, 10);
	DDX_Radio(pDX, IDC_RADIO1, m_Mode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJpegDlg, CDialog)
	//{{AFX_MSG_MAP(CJpegDlg)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER1, OnCustomdrawSlider)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJpegDlg message handlers

BOOL CJpegDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_QualitySlider.SetRange(0, 10); 
	m_QualitySlider.SetPos(m_Quality);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CJpegDlg::OnCustomdrawSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int pos = m_QualitySlider.GetPos();
	CString numStr;
	numStr.Format("%d", pos);
	SetDlgItemText(IDC_EDIT1, numStr);

	*pResult = 0;
}
/////////////////////////////////////////////////////////////////////////////
// CTgaDlg dialog


CTgaDlg::CTgaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTgaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTgaDlg)
	m_Mode = 0;
	//}}AFX_DATA_INIT
}


void CTgaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTgaDlg)
	DDX_Radio(pDX, IDC_RADIO1, m_Mode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTgaDlg, CDialog)
	//{{AFX_MSG_MAP(CTgaDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTgaDlg message handlers
/////////////////////////////////////////////////////////////////////////////
// CTiffDlg dialog


CTiffDlg::CTiffDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTiffDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTiffDlg)
	m_Mode = -1;
	//}}AFX_DATA_INIT
}


void CTiffDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTiffDlg)
	DDX_Radio(pDX, IDC_RADIO1, m_Mode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTiffDlg, CDialog)
	//{{AFX_MSG_MAP(CTiffDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTiffDlg message handlers
