// RayTrace3DDoc.h : interface of the CRayTrace3DDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RAYTRACE3DDOC_H__44C6C00A_A9BF_11D3_9E40_BDDE6EB23F17__INCLUDED_)
#define AFX_RAYTRACE3DDOC_H__44C6C00A_A9BF_11D3_9E40_BDDE6EB23F17__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RayTracer/include/Oort.h"
#include "RayTracer/include/World.h"


class CRayTrace3DDoc : public CDocument, public World
{
protected: // create from serialization only
	CRayTrace3DDoc();
	DECLARE_DYNCREATE(CRayTrace3DDoc)

// Attributes
//3DStudio file object///////////////////////////////
protected:
	C3DStudio		m_Obj3DS; //from World

public:
	SimpleList<UINT> m_CameraIDList;

	int				m_LastX;		//mouse move parameters
	int				m_LastY;	//FROM WORLD

	int				m_iCamera;
	BOOL			m_SceneLoaded;
	void	DoUpdateSelectCamera(int iCamera, CCmdUI* pCmdUI);
	void	DoSelectCamera(int iCamera);

	BOOL	SceneLoaded() { return m_SceneLoaded; } //used in drawing the scene

	//to set the materials altered flag from the View
	void	SetMaterialsChanged(BOOL state) { m_MaterialsChanged = state; }
	void	SetCameraChanged(BOOL state) { m_CameraChanged = state; }

	//for Opening 3DStudio files from windows
	void	OnOpen3DSFile();
	//ADDED FROM WORLD.H
	void	MouseDownAt(int x, int y);
	void	MouseMoveTo(int x, int y);
//	void	InitOpenGL(CDC* pDC);
//	void	DestroyOpenGL();
	void	DrawOpenGL();
//	BOOL	CreateRenderingContextGL(int colorDepth);
//	void	ResizeViewportGL(int cx, int cy);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRayTrace3DDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRayTrace3DDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRayTrace3DDoc)
	afx_msg void OnFileOpen();
	afx_msg void OnAutoCenter();
	afx_msg void OnBackColor();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RAYTRACE3DDOC_H__44C6C00A_A9BF_11D3_9E40_BDDE6EB23F17__INCLUDED_)
