// RayTrace3DView.h : interface of the CRayTrace3DView class
//
/////////////////////////////////////////////////////////////////////////////

#include "MaterialDialog.h"
#include "RayTracer/include/Oort.h"
#include "RayTracer/include/World.h"
#include "RayTrace3DDoc.h"
#include "RTWindow.h"

#if !defined(AFX_RAYTRACE3DVIEW_H__44C6C00C_A9BF_11D3_9E40_BDDE6EB23F17__INCLUDED_)
#define AFX_RAYTRACE3DVIEW_H__44C6C00C_A9BF_11D3_9E40_BDDE6EB23F17__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct {
	CRTWindow* window;
	CRayTrace3DDoc* pDoc;
} THREADPARAMS;


class CRayTrace3DView : public CView
{
protected: // create from serialization only
	CRayTrace3DView();
	DECLARE_DYNCREATE(CRayTrace3DView)

// Attributes
public:
	CRayTrace3DDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRayTrace3DView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRayTrace3DView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	static UINT	RayTraceThreadFunc(LPVOID pParam);
	BOOL ClosingTime();
protected:
	BOOL	CreateRenderingContextGL(int colorDepth);
	void	SaveScreenShotGL();

// Generated message map functions
protected:
	//{{AFX_MSG(CRayTrace3DView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMatDialog();
	afx_msg void OnRender();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg LRESULT OnMatDialogDestroyed(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMaterialsApply(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRTWindowDestroyed(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnChangeDatabase(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnStopRender(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()

public:
	CMaterialDialog*		m_pMatDlg;
	SimpleList<CRTWindow *> m_CRTWindowList;
	ImageFile*				m_pCurrentRenderImage; //pointer to the image being rendered
	HGLRC					m_hRC;  //FROM WORLD
	CDC*					m_pDC;

};

#ifndef _DEBUG  // debug version in RayTrace3DView.cpp
inline CRayTrace3DDoc* CRayTrace3DView::GetDocument()
   { return (CRayTrace3DDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RAYTRACE3DVIEW_H__44C6C00C_A9BF_11D3_9E40_BDDE6EB23F17__INCLUDED_)
