// ===================================================================
// 	File: init.cpp								12/27/1999
//	By Konstantin Khanyants						kon@unix.temple.edu
//	Description:
//		This file contains declarations of static member functions,
//		plus some miscellaneous functions that don't make sense to
//		put elsewhere (such as Report(), which reports on the ray
//		tracer's statistics, and Usage(), which tells the user
//		the valid command-line options).
//
//	Original Copyright:     The Object-Oriented Ray Tracer (OORT)
//            				Copyright (C) 1993 by Nicholas Wilt.
//
// ===================================================================

#include "stdafx.h"
#include "include/Oort.h"
#include "include/World.h"

NoiseMaker *GlobalNoise::Noise = 0;
WaveSource *GlobalNoise::Waves = 0;
FreqSource *GlobalNoise::Freqs = 0;

//char *Statistics::AppendTo = 0;

long Statistics::PrimaryRays = 0L;
long Statistics::ShadowRays = 0L;
long Statistics::ReflectedRays = 0L;
long Statistics::TransmittedRays = 0L;
long Statistics::ShadowTotal = 0L;
long Statistics::ShadowHits = 0L;
long Statistics::NearestTotal = 0L;
long Statistics::NearestHits = 0L;
float Statistics::RestrictedVolume = 0;
float Statistics::TotalVolume = 0;
long Statistics::PrepTime;
long Statistics::RenderTime;
long Statistics::EpsilonTotal = 0;
long Statistics::EpsilonNeeded = 0;

float Statistics::HierarchyHeuristic;

unsigned long Statistics::RayPixHist[16] = {0};

long Statistics::Intersections::BBox = 0;
long Statistics::Intersections::Plane = 0;
long Statistics::Intersections::Polygon = 0;
long Statistics::Intersections::Sphere = 0;
long Statistics::Intersections::Triangle = 0;

long Statistics::Objects::BBox;
long Statistics::Objects::Plane;
long Statistics::Objects::Polygon;
long Statistics::Objects::Sphere;
long Statistics::Objects::Triangle;

float Limits::Threshold = 1.0f;
float Limits::Small = 0.001f;    //was 0.1
float Limits::Infinity = 100000.0f;