//	File: 3DSPriv.h
//	Description: This file contains private defines that 
//				 are only used when reading chunks from the 3DS file
//	Usage:		 This file is only included in 3DSFile.cpp			 



/* Priv */ /* chunktag3ds - enumeration of all possible chunk type identifiers. See appendix for */
/* Priv */ /* more information concerning chunk structures */   
//* Priv */ typedef enum
///* Priv */ {

/* Priv */    /* 3DS File Chunk IDs */

#define		M3DMAGIC			0x4D4D
///* Priv */    SMAGIC                 = 0x2D2D,
///* Priv */    LMAGIC                 = 0x2D3D,
///* Priv */    MLIBMAGIC              = 0x3DAA,
#define		MATMAGIC			0x3DFF
#define		M3D_VERSION			0x0002
///* Priv */    M3D_KFVERSION          = 0x0005,

/* Priv */    /* Mesh Chunk Ids */

#define		MDATA				0x3D3D
#define		MESH_VERSION        0x3D3E
#define		COLOR_F				0x0010
#define		COLOR_24			0x0011
//* Priv */    LIN_COLOR_24           = 0x0012,
//* Priv */    COLOR_F	             = 0x0013,
#define		INT_PERCENTAGE		0x0030
#define		FLOAT_PERCENTAGE	0x0031

#define		MASTER_SCALE        0x0100

#define		BIT_MAP				0x1100
#define		USE_BIT_MAP         0x1101
#define		SOLID_BGND          0x1200
#define		USE_SOLID_BGND      0x1201
#define		V_GRADIENT          0x1300
#define		USE_V_GRADIENT      0x1301

//* Priv */    LO_SHADOW_BIAS         = 0x1400,
//* Priv */    HI_SHADOW_BIAS         = 0x1410,
//* Priv */    SHADOW_MAP_SIZE        = 0x1420,
//* Priv */    SHADOW_SAMPLES         = 0x1430,
//* Priv */    SHADOW_RANGE           = 0x1440,
//* Priv */    SHADOW_FILTER          = 0x1450,
//* Priv */    RAY_BIAS               = 0x1460,
//* Priv */  
//* Priv */    O_CONSTS               = 0x1500,
//* Priv */  
#define		AMBIENT_LIGHT		0x2100

//* Priv */    FOG                    = 0x2200,
//* Priv */    USE_FOG                = 0x2201,
//* Priv */    FOG_BGND               = 0x2210,
//* Priv */    DISTANCE_CUE           = 0x2300,
//* Priv */    USE_DISTANCE_CUE       = 0x2301,
//* Priv */    LAYER_FOG              = 0x2302,
//* Priv */    USE_LAYER_FOG          = 0x2303,
//* Priv */    DCUE_BGND              = 0x2310,

#define		DEFAULT_VIEW		0x3000
#define		VIEW_TOP            0x3010
#define		VIEW_BOTTOM			0x3020
#define		VIEW_LEFT           0x3030
#define		VIEW_RIGHT          0x3040
#define		VIEW_FRONT          0x3050
#define		VIEW_BACK           0x3060
#define		VIEW_USER           0x3070
#define		VIEW_CAMERA         0x3080
#define		VIEW_WINDOW         0x3090

#define		NAMED_OBJECT        0x4000
#define		OBJ_HIDDEN          0x4010
#define		OBJ_VIS_LOFTER      0x4011
#define		OBJ_DOESNT_CAST     0x4012
#define		OBJ_MATTE           0x4013
#define		OBJ_FAST            0x4014
#define		OBJ_PROCEDURAL      0x4015
#define		OBJ_FROZEN          0x4016
#define		OBJ_DONT_RCVSHADOW  0x4017

#define		N_TRI_OBJECT        0x4100

#define		POINT_ARRAY         0x4110
#define		POINT_FLAG_ARRAY    0x4111
#define		FACE_ARRAY          0x4120
#define		MSH_MAT_GROUP       0x4130
//* Priv */    OLD_MAT_GROUP          = 0x4131,
#define		TEX_VERTS			0x4140
#define		SMOOTH_GROUP		0x4150
#define		MESH_MATRIX         0x4160
#define		MESH_COLOR          0x4165   
#define		MESH_TEXTURE_INFO   0x4170
//* Priv */    PROC_NAME              = 0x4181,
//* Priv */    PROC_DATA              = 0x4182,
//* Priv */    MSH_BOXMAP             = 0x4190,

//* Priv */    N_D_L_OLD              = 0x4400,

//* Priv */    N_CAM_OLD              = 0x4500,   

#define		N_DIRECT_LIGHT      0x4600
#define		DL_SPOTLIGHT        0x4610
#define		DL_OFF              0x4620
#define		DL_ATTENUATE        0x4625
#define		DL_RAYSHAD          0x4627
#define		DL_SHADOWED         0x4630
#define		DL_LOCAL_SHADOW     0x4640
#define		DL_LOCAL_SHADOW2    0x4641
#define		DL_SEE_CONE         0x4650
#define		DL_SPOT_RECTANGULAR 0x4651
#define		DL_SPOT_OVERSHOOT   0x4652
#define		DL_SPOT_PROJECTOR   0x4653
#define		DL_EXCLUDE          0x4654
//* Priv */    DL_RANGE               = 0x4655, /* Not used in R3 */
#define		DL_SPOT_ROLL        0x4656
#define		DL_SPOT_ASPECT      0x4657
#define		DL_RAY_BIAS         0x4658
#define		DL_INNER_RANGE 		0x4659
#define		DL_OUTER_RANGE 		0x465A
#define		DL_MULTIPLIER		0x465B

#define		N_AMBIENT_LIGHT     0x4680

#define		N_CAMERA            0x4700
#define		CAM_SEE_CONE        0x4710
#define		CAM_RANGES          0x4720

//* Priv */    HIERARCHY              = 0x4F00,
//* Priv */    PARENT_OBJECT          = 0x4F10,
//* Priv */    PIVOT_OBJECT           = 0x4F20,
//* Priv */    PIVOT_LIMITS           = 0x4F30,
//* Priv */    PIVOT_ORDER            = 0x4F40,
//* Priv */    XLATE_RANGE            = 0x4F50,

/* Priv */    /* Viewport description chunks */

//* Priv */    VIEWPORT_LAYOUT_OLD    = 0x7000,
//* Priv */    VIEWPORT_DATA_OLD      = 0x7010,
#define		VIEWPORT_LAYOUT     0x7001
#define		VIEWPORT_DATA       0x7011
#define		VIEWPORT_DATA_3     0x7012
#define		VIEWPORT_SIZE       0x7020
//* Priv */    NETWORK_VIEW          = 0x7030,

/* Priv */    /* Material Chunk IDs */

#define		MAT_ENTRY           0xAFFF
#define		MAT_NAME            0xA000
#define		MAT_AMBIENT         0xA010
#define		MAT_DIFFUSE         0xA020
#define		MAT_SPECULAR        0xA030
#define		MAT_SHININESS       0xA040
#define		MAT_SHIN2PCT		0xA041
#define		MAT_SHIN3PCT		0xA042
#define		MAT_TRANSPARENCY  	0xA050
#define		MAT_XPFALL          0xA052
#define		MAT_REFBLUR         0xA053

#define		MAT_SELF_ILLUM      0xA080
#define		MAT_TWO_SIDE        0xA081
#define		MAT_DECAL           0xA082
#define		MAT_ADDITIVE        0xA083
#define		MAT_SELF_ILPCT  	0xA084
#define		MAT_WIRE			0xA085
#define		MAT_SUPERSMP		0xA086
#define		MAT_WIRESIZE		0xA087
#define		MAT_FACEMAP		 	0xA088
#define		MAT_XPFALLIN		0xA08A
#define		MAT_PHONGSOFT	 	0xA08C
#define		MAT_WIREABS  		0xA08E

#define		MAT_SHADING         0xA100

#define		MAT_TEXMAP          0xA200
#define		MAT_OPACMAP         0xA210
#define		MAT_REFLMAP         0xA220
#define		MAT_BUMPMAP         0xA230
#define		MAT_SPECMAP         0xA204
#define		MAT_USE_XPFALL      0xA240
#define		MAT_USE_REFBLUR     0xA250
#define		MAT_BUMP_PERCENT    0xA252

#define		MAT_MAPNAME         0xA300
#define		MAT_ACUBIC          0xA310

//* Priv */    MAT_SXP_TEXT_DATA      = 0xA320,
//* Priv */    MAT_SXP_TEXT2_DATA     = 0xA321,
//* Priv */    MAT_SXP_OPAC_DATA      = 0xA322,
//* Priv */    MAT_SXP_BUMP_DATA      = 0xA324,
//* Priv */    MAT_SXP_SPEC_DATA      = 0xA325,
//* Priv */    MAT_SXP_SHIN_DATA 	  = 0xA326,
//* Priv */    MAT_SXP_SELFI_DATA 	  = 0xA328,
//* Priv */    MAT_SXP_TEXT_MASKDATA  = 0xA32A,
//* Priv */    MAT_SXP_TEXT2_MASKDATA = 0xA32C,
//* Priv */    MAT_SXP_OPAC_MASKDATA  = 0xA32E,
//* Priv */    MAT_SXP_BUMP_MASKDATA  = 0xA330,
//* Priv */    MAT_SXP_SPEC_MASKDATA  = 0xA332,
//* Priv */    MAT_SXP_SHIN_MASKDATA  = 0xA334,
//* Priv */    MAT_SXP_SELFI_MASKDATA = 0xA336,
//* Priv */    MAT_SXP_REFL_MASKDATA  = 0xA338,
#define		MAT_TEX2MAP 		0xA33A
#define		MAT_SHINMAP 		0xA33C
#define		MAT_SELFIMAP 	  	0xA33D
#define		MAT_TEXMASK 		0xA33E
#define		MAT_TEX2MASK 		0xA340
#define		MAT_OPACMASK 		0xA342
#define		MAT_BUMPMASK 	 	0xA344
#define		MAT_SHINMASK 		0xA346
#define		MAT_SPECMASK 		0xA348
#define		MAT_SELFIMASK 		0xA34A
#define		MAT_REFLMASK 		0xA34C
#define		MAT_MAP_TILINGOLD   0xA350
//relevant map fields
#define		MAT_MAP_TILING 		0xA351
#define		MAT_MAP_TEXBLUR_OLD 0xA352
#define		MAT_MAP_TEXBLUR 	0xA353
#define		MAT_MAP_USCALE 		0xA354
#define		MAT_MAP_VSCALE 		0xA356
#define		MAT_MAP_UOFFSET 	0xA358
#define		MAT_MAP_VOFFSET 	0xA35A
#define		MAT_MAP_ANG 		0xA35C
#define		MAT_MAP_COL1 		0xA360
#define		MAT_MAP_COL2 		0xA362
#define		MAT_MAP_RCOL 		0xA364
#define		MAT_MAP_GCOL 	 	0xA366
#define		MAT_MAP_BCOL 		0xA368

//} chunktag3ds;