// ===================================================================
//  File: distrib.h						12/26/1999
//	By Konstantin Khnayants				kon@unix.temple.edu
//	Description:
//		Declares functions used to implement the adaptive
//		supersampling scheme for ray distribution.
//		It's hard to unify the code for different types of
//		ray (primary, secondary and shadow), but common pieces 
//		of code have been collected here.
//
//	Original Copyright:     The Object-Oriented Ray Tracer (OORT)
//            				Copyright (C) 1993 by Nicholas Wilt.
//
// ===================================================================


#ifndef _DISTRIB_

#define _DISTRIB_


// Returns the distance from p to the nearest point in arr.
float MinDist(const Vector3D& p, const Vector3D *arr, int n);

// Return nonzero if the contrast given by the min and max doesn't meet
// the tolerance given (i.e., returns nonzero if more rays are needed).
int MoreRays(const RGBColor& minC, const RGBColor& maxC, const RGBColor& tol);

#endif