// ===================================================================
//  File: MeshListGL.h					5/1/2000
//	By Konstantin Khanyants
//	Description:
//		Class that is used when compiling OpenGL display
//		lists from vertex arrays that define the polygonal
//		objects imported from 3D Studio
//
// ===================================================================

#ifndef _MESH_LIST_GL_

#define _MESH_LIST_GL_

//new class based on the struct type before it
class MeshListGL : public SimpleList<MeshGL *> {
public:
	MeshListGL();
	~MeshListGL() { DeleteMeshList(); } //delete all of the objects
	virtual void BuildDisplayListGL();
	virtual void ClearDisplayListGL();
	virtual void DrawObjectsGL();
	virtual void SetVersion(int version) { m_Version = version; }
	virtual void SetBackColor(RGBColor& col) { m_BackColor = col; }
	virtual void SetAmbientLight(RGBColor& col) { m_Ambient = col; }
	virtual void DeleteMeshList();
private:
	virtual void CheckOpenGLError();

	GLint		m_MainListGL;	//an internally built OpenGL display list
	int			m_Version;		//set during the database initialization in C3DStudio
	RGBColor	m_BackColor;	//also set during initialization
	RGBColor	m_Ambient;		//ambient color for the scene set at initialization
};

#endif