// ===================================================================
//  File: OpenGLTypes.h					5/1/2000
//	By Konstantin Khanyants
//	Description:
//		Contains everything needed to integrate the database into
//		OpenGL form.
//
// ===================================================================


#ifndef _GLTYPES_H_

#define _GLTYPES_H_

typedef float* Vector4f;
typedef float* Vector3f;
typedef float* Color4f;

class HallSurface;
template<class T> class SimpleList;

typedef struct {
	float s, t;
} TexPointGL;

typedef struct {
	HallSurface* SurfPtr;
	GLint IndexCount;
	GLint *Indices;
} FaceGroup;

typedef struct {
	FaceGroup* MatGroups;
	int nMatGroups;
} FaceListGL;

//this is the only data structure left over from the
// procedural implementation
typedef struct {
	CString MeshName;
    GLuint ListName;
    BOOL Visible;
    GLuint Count;				// vertex count, only needed for auto center calculation
    Vector3f Vertices;			// comprises all vertices of the object in no particular order
    Vector3f Normals;
    TexPointGL *TexCoords;
	FaceListGL Faces;			// a list of face groups, each comprising a material description and
								// a list of indices into the VerticesArray array
} MeshGL;    

inline float Trunc(double x);
inline float* MakeHVector(float x, float y, float z, float w);
inline float* MakeVector(float x, float y, float z);
int RoundDownToPowerOf2(int Value);

inline float* MakeHVector(float x, float y, float z, float w)
{ 
	float *ptr = new float[4];
	ptr[0] = x;
	ptr[1] = y;
	ptr[2] = z;
	ptr[3] = w;

	return ptr;
}

inline float* MakeVector(float x, float y, float z)
{
	float *ptr = new float[3];
	ptr[0] = x;
	ptr[1] = y;
	ptr[2] = z;

	return ptr;
}

#endif