// RenderDialog.cpp : implementation file
//

#include "stdafx.h"
#include "RayTrace3D.h"
#include "RenderDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRenderDialog dialog


CRenderDialog::CRenderDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CRenderDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRenderDialog)
	m_Mode = 0;
	//}}AFX_DATA_INIT

	m_Width = 320;
	m_Height = 240;
	m_Depth = 3;
}


void CRenderDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRenderDialog)
	DDX_Control(pDX, IDC_DEPTH, m_DepthEdit);
	DDX_Control(pDX, IDC_RENDERWIDTH, m_WidthEdit);
	DDX_Control(pDX, IDC_RENDERHEIGHT, m_HeightEdit);
	DDX_Radio(pDX, IDC_RADIO1, m_Mode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRenderDialog, CDialog)
	//{{AFX_MSG_MAP(CRenderDialog)
	ON_NOTIFY(UDN_DELTAPOS, IDC_RENDHEIGHT_SPIN, OnHeightSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_RENDWIDTH_SPIN, OnWidthSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_DEPTHSPIN, OnDepthSpin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRenderDialog message handlers

void CRenderDialog::OnHeightSpin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	if (!m_HeightEdit.UpdateEditValue(-(pNMUpDown->iDelta)))
		AfxMessageBox("Please enter a valid value");

	*pResult = 0;
}

void CRenderDialog::OnWidthSpin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	if (!m_WidthEdit.UpdateEditValue(-(pNMUpDown->iDelta)))
		AfxMessageBox("Please enter a valid value");

	*pResult = 0;
}

BOOL CRenderDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_HeightEdit.SetLimitText(6);
	m_HeightEdit.SetRange(0, 4000);
	m_HeightEdit.SetEditValue(m_Height);

	m_WidthEdit.SetLimitText(6);
	m_WidthEdit.SetRange(0, 4000);
	m_WidthEdit.SetEditValue(m_Width);

	m_DepthEdit.SetLimitText(1);
	m_DepthEdit.SetRange(1, 6);
	m_DepthEdit.SetEditValue(m_Depth);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRenderDialog::OnOK() 
{
	UpdateData();
	m_HeightEdit.GetEditValue(m_Height);
	m_WidthEdit.GetEditValue(m_Width);
	m_DepthEdit.GetEditValue(m_Depth);

	CDialog::OnOK();
}

void CRenderDialog::OnDepthSpin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	if (!m_DepthEdit.UpdateEditValue(-(pNMUpDown->iDelta)))
		AfxMessageBox("Please enter a valid value");

	*pResult = 0;
}
