// SupportCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "RayTrace3D.h"
#include "NumEdit.h"
#include <ctype.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNumEdit
CNumEdit::CNumEdit()
{
}

CNumEdit::~CNumEdit()
{
}

BOOL CNumEdit::GetEditFloatValue(float& def_float)
{
	CString string;
	char *buf, *end;
	float dummy;

	GetWindowText(string);
	buf = string.GetBuffer(0);
	
	dummy = float(strtod(buf, &end));
	//if number was not converted then error
	if (!strcmp(buf, end) || ((dummy < m_dLower) || (dummy > m_dUpper)))
		return FALSE;
	else
	{
		def_float = dummy;
		return TRUE;
	}
	
}

//used to get the current value in the edit control and it's validity
BOOL CNumEdit::GetEditValue(int& def_num)
{
	CString string;
	char *buf, *end;
	int dummy;

	GetWindowText(string);
	buf = string.GetBuffer(0);
	
	dummy = (int) strtol(buf, &end, 10);
	
	//if number was not converted then error
	if (!strcmp(buf, end) || ((dummy < m_Lower) || (dummy > m_Upper)))
		return FALSE;
	else
	{
		def_num = dummy;
		return TRUE;
	}
	
}

//used to set the upper and lower bound member variables
void CNumEdit::SetRange(int lower_bound, int upper_bound)
{
	m_Lower = lower_bound;
	m_Upper = upper_bound;
	floatSet = FALSE;
}

//used to set the upper and lower bound member variables
void CNumEdit::SetFloatRange(float lower_bound, float upper_bound)
{
	m_dLower = lower_bound;
	m_dUpper = upper_bound;
	floatSet = TRUE;
}


//used for incrementing and the m_data by the amount in increment 
// and then assigning it to the edit control
BOOL CNumEdit::UpdateEditValue(int increment)
{
	int editNum = 0;		//dummy number used for testing
	BOOL noError = TRUE;	//error flag

	//if the function returns without an error then increment
	if (noError = GetEditValue(editNum))
		editNum += increment;

	//check the noError flag and lower and upper bounds set by 
	//member variables
	if ((editNum >= m_Lower) && (editNum <= m_Upper) && noError)
	{
	//	m_data = editNum;		//assign the dummy to the data
		SetEditValue(editNum);	//assign the data to the contol
	}

	return noError;
}

BOOL CNumEdit::UpdateEditFloatValue(float increment)
{
	float editFloat = 0.00;		//dummy number used for testing
	BOOL noError = TRUE;	//error flag

	//if the function returns without an error then increment
	if (noError = GetEditFloatValue(editFloat))
		editFloat += increment;

	//check the noError flag and lower and upper bounds set by 
	//member variables
	if ((editFloat >= m_dLower) && (editFloat <= m_dUpper) && noError)
	{
	//	m_data = editFloat;		//assign the dummy to the data
		SetEditFloatValue(editFloat);	//assign the data to the contol
	}

	return noError;
}


//sets the edit control to the number in value
void CNumEdit::SetEditValue(int value)
{
	CString cs;
	cs.Format ("%d",value);	
	SetWindowText(cs);
}

//sets the edit control to the number in value
void CNumEdit::SetEditFloatValue(float value)
{
	CString cs;
	cs.Format ("%1.4f",value);	
	SetWindowText(cs);
}


BEGIN_MESSAGE_MAP(CNumEdit, CEdit)
	//{{AFX_MSG_MAP(CNumEdit)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNumEdit message handlers

void CNumEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	if (((nChar >= _T('0')) && (nChar <= _T('9')) || (nChar == _T('-'))
		|| (nChar == '.' && floatSet)) || (nChar == VK_BACK))
		CEdit::OnChar(nChar, nRepCnt, nFlags);
}
